Subject: Re: Working copy revision and push pain

From: Johan Herland <[email-masked]>
Date: Mon, 24 Mar 2008 19:00:38 +0100

On Monday 24 March 2008, Johannes Schindelin wrote:
> On Sun, 23 Mar 2008, Johan Herland wrote:
> > I'm starting to think it's worth changing the default behaviour of push 
> > as follows:
> > 
> > Upon receiving a push into a non-bare repository, if the working copy is 
> > on the same branch as is being pushed, then refuse the push with a 
> > helpful message describing why the push was refused, and how to resolve 
> > this issue (i.e. referring to the tutorials you mention).
> > 
> > This would:
> > - Not clobber the working copy
> > - Tell newbies what happened and why
> > - Hopefully make this issue pop up less frequently
> > - Not affect you if you only push into bare repos
> > - Not affect you if you take care to never push into a checked-out 
> >   branch
> > 
> > Of course, you should be able to set a config option to get the old 
> > behaviour, and from there you can write hooks to either update the 
> > working copy, or detach HEAD, or whatever you please.
> 
> I think I sent out a sensible patch, which does not change the behaviour 
> in existing repositories.  This should be safer (read: nicer) for 
> Git old-timers.

Yes, I'm following the discussion between you and Junio with great interest. Will post if I have anything worthwhile to contribute. So far you both make a lot of sense.

Thanks a lot for the patch.

Have fun! :)

...Johan
-- 
Johan Herland, <[email-masked]>
www.herland.net